# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RiskBehaviorArgs', 'RiskBehavior']

@pulumi.input_type
class RiskBehaviorArgs:
    def __init__(__self__, *,
                 account_id: pulumi.Input[str],
                 behaviors: Optional[pulumi.Input[Sequence[pulumi.Input['RiskBehaviorBehaviorArgs']]]] = None):
        """
        The set of arguments for constructing a RiskBehavior resource.
        :param pulumi.Input[str] account_id: The account identifier to target for the resource.
        :param pulumi.Input[Sequence[pulumi.Input['RiskBehaviorBehaviorArgs']]] behaviors: Zero Trust risk behaviors configured on this account
        """
        pulumi.set(__self__, "account_id", account_id)
        if behaviors is not None:
            pulumi.set(__self__, "behaviors", behaviors)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Input[str]:
        """
        The account identifier to target for the resource.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter
    def behaviors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['RiskBehaviorBehaviorArgs']]]]:
        """
        Zero Trust risk behaviors configured on this account
        """
        return pulumi.get(self, "behaviors")

    @behaviors.setter
    def behaviors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['RiskBehaviorBehaviorArgs']]]]):
        pulumi.set(self, "behaviors", value)


@pulumi.input_type
class _RiskBehaviorState:
    def __init__(__self__, *,
                 account_id: Optional[pulumi.Input[str]] = None,
                 behaviors: Optional[pulumi.Input[Sequence[pulumi.Input['RiskBehaviorBehaviorArgs']]]] = None):
        """
        Input properties used for looking up and filtering RiskBehavior resources.
        :param pulumi.Input[str] account_id: The account identifier to target for the resource.
        :param pulumi.Input[Sequence[pulumi.Input['RiskBehaviorBehaviorArgs']]] behaviors: Zero Trust risk behaviors configured on this account
        """
        if account_id is not None:
            pulumi.set(__self__, "account_id", account_id)
        if behaviors is not None:
            pulumi.set(__self__, "behaviors", behaviors)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[pulumi.Input[str]]:
        """
        The account identifier to target for the resource.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter
    def behaviors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['RiskBehaviorBehaviorArgs']]]]:
        """
        Zero Trust risk behaviors configured on this account
        """
        return pulumi.get(self, "behaviors")

    @behaviors.setter
    def behaviors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['RiskBehaviorBehaviorArgs']]]]):
        pulumi.set(self, "behaviors", value)


class RiskBehavior(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[str]] = None,
                 behaviors: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RiskBehaviorBehaviorArgs', 'RiskBehaviorBehaviorArgsDict']]]]] = None,
                 __props__=None):
        """
        The [Risk Behavior](https://developers.cloudflare.com/cloudflare-one/insights/risk-score/) resource allows you to configure Cloudflare Risk Behaviors for an account.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: The account identifier to target for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['RiskBehaviorBehaviorArgs', 'RiskBehaviorBehaviorArgsDict']]]] behaviors: Zero Trust risk behaviors configured on this account
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RiskBehaviorArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The [Risk Behavior](https://developers.cloudflare.com/cloudflare-one/insights/risk-score/) resource allows you to configure Cloudflare Risk Behaviors for an account.

        :param str resource_name: The name of the resource.
        :param RiskBehaviorArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RiskBehaviorArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[str]] = None,
                 behaviors: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RiskBehaviorBehaviorArgs', 'RiskBehaviorBehaviorArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RiskBehaviorArgs.__new__(RiskBehaviorArgs)

            if account_id is None and not opts.urn:
                raise TypeError("Missing required property 'account_id'")
            __props__.__dict__["account_id"] = account_id
            __props__.__dict__["behaviors"] = behaviors
        super(RiskBehavior, __self__).__init__(
            'cloudflare:index/riskBehavior:RiskBehavior',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account_id: Optional[pulumi.Input[str]] = None,
            behaviors: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RiskBehaviorBehaviorArgs', 'RiskBehaviorBehaviorArgsDict']]]]] = None) -> 'RiskBehavior':
        """
        Get an existing RiskBehavior resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: The account identifier to target for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['RiskBehaviorBehaviorArgs', 'RiskBehaviorBehaviorArgsDict']]]] behaviors: Zero Trust risk behaviors configured on this account
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RiskBehaviorState.__new__(_RiskBehaviorState)

        __props__.__dict__["account_id"] = account_id
        __props__.__dict__["behaviors"] = behaviors
        return RiskBehavior(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Output[str]:
        """
        The account identifier to target for the resource.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter
    def behaviors(self) -> pulumi.Output[Optional[Sequence['outputs.RiskBehaviorBehavior']]]:
        """
        Zero Trust risk behaviors configured on this account
        """
        return pulumi.get(self, "behaviors")

